<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-row>
        <el-col :span="12">
          <el-form-item label="井号" prop="wellName">
            <el-input v-model="formData.wellName" placeholder="请输入井号" />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="井型/井别" prop="wellType">
            <el-select v-model="formData.wellType" placeholder="请选择井型/井别">
              <el-option label="请选择字典生成" value="" />
            </el-select>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="施工地点" prop="location">
            <el-input v-model="formData.location" placeholder="请输入施工地点" />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="施工工艺" prop="technique">
            <el-input v-model="formData.technique" placeholder="请输入施工工艺" />
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="设计工作量" prop="workloadDesign">
            <el-input v-model="formData.workloadDesign" placeholder="请输入设计工作量" />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="所属队伍" prop="workloadDesign">
            <el-input v-model="formData.workloadDesign" placeholder="请输入设计工作量" />
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" type="textarea" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { IotProjectTaskApi, IotProjectTaskVO } from '@/api/pms/iotprojecttask'

/** 项目信息任务拆分 表单 */
defineOptions({ name: 'IotProjectTaskForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  projectId: undefined,
  wellName: undefined,
  wellType: undefined,
  location: undefined,
  technique: undefined,
  workloadDesign: undefined,
  userName: undefined,
  userId: undefined,
  remark: undefined
})
const formRules = reactive({})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await IotProjectTaskApi.getIotProjectTask(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as IotProjectTaskVO
    if (formType.value === 'create') {
      await IotProjectTaskApi.createIotProjectTask(data)
      message.success(t('common.createSuccess'))
    } else {
      await IotProjectTaskApi.updateIotProjectTask(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    projectId: undefined,
    wellName: undefined,
    wellType: undefined,
    location: undefined,
    technique: undefined,
    workloadDesign: undefined,
    userName: undefined,
    userId: undefined,
    remark: undefined
  }
  formRef.value?.resetFields()
}
</script>
